unit About;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ShellAPI;

const NoiseWidth=100;
      NoiseHeight=79;

type
  TAboutForm = class(TForm)
    NoiseMaker: TTimer;
    LVidGrab: TLabel;
    LDescription1: TLabel;
    LDescription2: TLabel;
    LFrom: TLabel;
    LMail: TSpeedButton;
    BOK: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure NoiseMakerTimer(Sender: TObject);
    procedure LMailClick(Sender: TObject);
    procedure BOKClick(Sender: TObject);
  private
    { Private declarations }
    Logo,Background:TBitmap;
    Noise:TBitmap;
    procedure Renoise;
  public
    { Public declarations }
  end;

var
  AboutForm: TAboutForm;

implementation

{$R *.dfm}
{$R vglogo.res}

procedure TAboutForm.FormShow(Sender: TObject);
var Palette:PLogPalette;
    i:integer;
begin
  Background:=TBitmap.Create;
  Background.LoadFromResourceName(HInstance,'VIDGRAB_BACKGROUND');
  Logo:=TBitmap.Create;
  Logo.LoadFromResourceName(HInstance,'VIDGRAB_LOGO');
  Noise:=TBitmap.Create;
  Noise.PixelFormat:=pf8bit;
  GetMem(Palette,sizeof(TLogPalette)+sizeof(TPaletteEntry)*255);
  Palette^.palVersion:=$300;
  Palette^.palNumEntries:=256;
  for i:=0 to 255 do
    with Palette^.palPalEntry[i] do begin
      peRed:=i; peGreen:=i; peBlue:=i;
    end;
  Noise.Palette:=CreatePalette(Palette^);
  FreeMem(Palette);
  Noise.Width:=NoiseWidth;
  Noise.Height:=NoiseHeight;
  Renoise;
  NoiseMaker.Enabled:=true;
end;

procedure TAboutForm.FormHide(Sender: TObject);
begin
  NoiseMaker.Enabled:=false;
  DeleteObject(Noise.Palette);
  Noise.Free;
  Logo.Free;
  Background.Free;
end;

procedure TAboutForm.FormPaint(Sender: TObject);
var X,Y:integer;
begin
  Y:=0;
  while (Y<ClientHeight) do begin
    X:=0;
    while (X<ClientWidth) do begin
      Canvas.Draw(X,Y,Background);
      inc(X,64);
    end;
    inc(Y,64);
  end;
  Canvas.Draw(10,10,Logo);
  Canvas.Draw(44,68,Noise);
end;

procedure TAboutForm.Renoise;
var Y,X:integer; Line:PByteArray;
    L:integer; P:^byte;
begin
  for Y:=(NoiseHeight-1) downto 0 do begin
    Line:=Noise.ScanLine[Y]; P:=@Line[0];
    L:=random(256);
    for X:=NoiseWidth downto 0 do begin
      L:=(L+random(512)+P^) SHR 2;
      P^:=L; inc(P);
    end;
  end;
end;

procedure TAboutForm.NoiseMakerTimer(Sender: TObject);
begin
  Renoise;
  Canvas.Draw(44,68,Noise);
end;

procedure TAboutForm.LMailClick(Sender: TObject);
begin
  ShellExecute(Handle,'open','mailto:martin.fiedler@gmx.net?subject=VidGrab',
               nil,nil,SW_SHOW);
end;

procedure TAboutForm.BOKClick(Sender: TObject);
begin
  ModalResult:=mrOK;
end;

end.
